###=== Step-by-step R ===###
## Part 2
myFun1 <- function(x) {
  
  return(x*exp(-2*x))
  
}

myFun1(-2.5)
myFun1(2.5)
myFun1(0)

myFun2 <- function(x,y) {
  
  return(y*exp(-2*x*y))
  
}

myFun2(x=2,y=1)
myFun2(2,1)


library(Ryacas)     # 
x <- ysym("x")      # define x as a symbolic variable
lim((sqrt(x+1)-1)/x, x, 0) # limit of sin(x)/x as x approaches 0



D(expression(x*exp(-2*x)),"x")
f1=makeFun(exp(-2 * x) - x * (exp(-2 * x) * 2)~ x )
f1(1)

D(expression(x*exp(x*y)),"x")


#library(mosaicCalc)
F1=mosaicCalc::D(x*exp(-2*x) ~ x)
F1(1)

mosaicCalc::D(x*exp(x*y) ~ x+y)


## Part 3

mosaicCalc::antiD(exp(2*x)~x)
F2=mosaicCalc::antiD(exp(2*x)~x)
F2(1)-F2(0)


mosaicCalc::antiD(x^3*exp(x^4+2)~x)
#Ex.5
F2=mosaicCalc::antiD((2+x)/sqrt(2*x+1) ~ x)
F2(4)-F2(0)

#Ex.6
F2=mosaicCalc::antiD(sqrt(x)/(9-x*sqrt(x))^2 ~ x)
F2(4)-F2(1)

#Ex.7
F2=mosaicCalc::antiD((x^2)*exp(-x) ~ x)
F2(7)-F2(0)

#Ex.8
F2=mosaicCalc::antiD((x^3)*(log(x))^2 ~ x)
F2(2)-F2(1)


#Part 4 
A=matrix(c(1,8,4,7,5,2,-3,6,-9),3,3)
B=matrix(c(0,1,2,7,5,-6,3,1,9),3,3)

A%*%B
B%*%A
A*B

solve(A)

t(A)

diag(A)


A=matrix(c(1,2,3,-3,-1,1,5,-3,4),3,3)
B=c(-9,19,-13)
solve(A,B)

rank(A)
rankMatrix(A)[1]

A=matrix(c(1,3,-2,-1,9,1,5,7,0),3,3)
det(A)

#library(matlib)
matlib::cofactor(A,1,1)
matlib::rowCofactors(A,1)
matlib::adjoint(A)
matlib::minor(A,1,1)

A=matrix(c(5,4,-2,-1),2,2)
eigen(A)

#Part 5 
#library(rootSolve)
f <- function(x) {6*x^2+6*x-12}
rootSolve::uniroot.all(f, c(-10,10))

dev.new();mosaic::plotFun(makeFun(2*x^3+3*x^2-12*x-7 ~ x), xlim=c(-5,5))

f <- function(x) {4*x^3-3*x^2}
rootSolve::uniroot.all(f, c(-10,10))


model <- function(x) c(F1 = 3*x[1]^2-4*x[2], 
                       F2 = -4*x[1]+4*x[2])
rootSolve::multiroot(f = model, start = c(1, 1))
rootSolve::multiroot(f = model, start = c(2, 2))


model <- function(x) c(F1 = x[2]-x[1]^3, 
                       F2 = x[1]-x[2]^3)
rootSolve::multiroot(f = model, start = c(0, 0))
rootSolve::multiroot(f = model, start = c(2, 2))
rootSolve::multiroot(f = model, start = c(-2.5, -2.5))


#Optimization
obj1 <- function(x) {2*x[1]^3+3*x[1]^2-12*x[1]-7}
optim(c(1,1),f=obj1)

obj2 <- function(x) {x[1]^4-x[1]^3}
optim(c(1,1),f=obj2)


obj3 <- function(x) {x[1]^3-4*x[1]*x[2]+2*x[2]^2}
optim(c(0,1),f=obj3)



library(lpSolve)
objective.in <- c(1, -2,3)
const.mat <- matrix(c(1, 1, 0, 1,0,1), nrow=2,
                    byrow=TRUE)
const.rhs <- c(3, 5)
const.dir <- c("=", "=")
optimum <- lpSolve::lp(direction="min", objective.in, const.mat,
              const.dir, const.rhs)
optimum$solution
optimum$objval



library(nloptr)
# Objective function
Obj_f <- function(x)
{
  return ( x[1]-2*x[2] + 3*x[3] )
}
# equality constraints
eval_g_eq <- function (x) {
  constr <- c(x[1] + x[2]-3,
              x[1] + x[3]-5)
  return (constr)
}
lb <- c(0, 0, 0)
ub <- c(5, 5, 5)
# Initial values
x0 <- c(3, 0, 2)
#Finally, define options for nloptr as follows:
opts <- list("algorithm"= "NLOPT_GN_ISRES",
             "xtol_rel"= 1.0e-10,
             "maxeval"= 160000,
             "tol_constraints_eq" = rep( 1.0e-10, 2 ))
# and then perform the optimization
res <- nloptr(
  x0          = x0,
  eval_f      = Obj_f,
  lb          = lb,
  ub          = ub,
  eval_g_eq = eval_g_eq,
  opts        = opts
)
print(res)

res$solution
res$objective









library(nloptr)
# Objective function
Obj_f <- function(x)
{
  return ( x[1]^2 + x[2]^2 + x[3]^2 )
}

# equality constraints
eval_g_eq <- function (x) {
  constr <- c(x[1] + x[2]-3,
              x[1] + x[3]-5)
  return (constr)
}
lb <- c(0, 0, 0)
ub <- c(5, 5, 5)
# Initial values
x0 <- c(3, 0.5, 2)
#Finally, define options for nloptr as follows:
  opts <- list("algorithm"= "NLOPT_GN_ISRES",
                "xtol_rel"= 1.0e-10,
                "maxeval"= 160000,
                "tol_constraints_eq" = rep( 1.0e-10, 2 ))
# and then perform the optimization
res <- nloptr(
  x0          = x0,
  eval_f      = Obj_f,
  lb          = lb,
  ub          = ub,
  eval_g_eq = eval_g_eq,
  opts        = opts
)
print(res)

names(res)

res$solution
res$objective



